import math
import sqlite3
import importlib
import tkinter as tk

import value


class window():
    """ 不正行為ウインドウ.

    不正行為ウインドウのプログラム群

    Args:
        root (instance): toplevel のインスタンス
        radioValue (int): ラジオボタンの値
        class_day (str): 日付
        class_time (int): 時間目
        ids (int): 生徒id
        name (str): 生徒名
        button_size (list): ボタンの幅と高さ
    """
    def __init__(
            self,
            root,
            radioValue,
            class_day,
            class_time,
            ids,
            name,
            button_size
    ):
        importlib.reload(value)
        self.ids = ids
        self.class_day = class_day
        self.class_time = class_time
        self.radioValue = radioValue
        self.radioValue.set(0)
        self.illegal_window = tk.Toplevel(
            root,
            width=button_size[0]*4,
            height=button_size[1]*(math.ceil(len(value.illegal)/4)+1)
            )
        self.illegal_window.title(name)
        k = 0
        for val in value.illegal:
            radio = tk.Radiobutton(
                self.illegal_window,
                text=val,
                variable=self.radioValue,
                anchor='w',
                value=k
            )
            radio.place(
                x=button_size[0]*(k % 4),
                y=button_size[1]*(k//4),
                width=button_size[0],
                height=button_size[1]
            )
            k += 1
        radio = tk.Button(
            self.illegal_window,
            text='キャンセル',
            command=self.input_window_cancel
        )
        radio.place(
            x=button_size[0]*0,
            y=button_size[1]*math.ceil(len(value.illegal)/4),
            width=button_size[0],
            height=button_size[1]
        )
        radio = tk.Button(
            self.illegal_window,
            text='OK',
            command=self.input_window_ok
        )
        radio.place(
            x=button_size[0]*3,
            y=button_size[1]*math.ceil(len(value.illegal)/4),
            width=button_size[0],
            height=button_size[1]
        )

    def input_window_cancel(self):
        """ キャンセルボタンが押されたとき.

        キャンセルボタンが押されたときにウインドウを閉じる
        """
        self.illegal_window.destroy()

    def input_window_ok(self):
        """ OKボタンが押されたとき.

        OKボタンが押されたときに処理をしてウインドウを閉じる
        """
        importlib.reload(value)
        self.illegal_window.destroy()
        i = 0
        sql = []
        illegal = []
        for buf in value.illegal:
            sql.append('illegal{0}'.format(i))
            illegal.append('0')
            i = i+1
        illegal[self.radioValue.get()] = '1'
        conn = sqlite3.connect(value.database_name)
        c = conn.cursor()
        c.execute('''INSERT INTO DataTable (
            date, class_time, id, {0}
            ) VALUES (
            "{1}",{2},{3},{4}
            )'''.format(
                ','.join(sql),
                self.class_day,
                self.class_time,
                self.ids,
                ','.join(illegal)
            )
        )
        conn.commit()
        conn.close()
